-- Cooldown frame container
local CooldownFrameContainer = CreateFrame("Frame", "TTB_CooldownFrameContainer", UIParent)
CooldownFrameContainer:SetSize(310, 60)
CooldownFrameContainer:SetPoint("CENTER", 100, 0)
CooldownFrameContainer:SetBackdrop({
	bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
	tile = true, tileSize = 16, edgeSize = 16,
	insets = { left = 3, right = 3, top = 5, bottom = 3 }
})
CooldownFrameContainer:Hide()

-- Make movable
CooldownFrameContainer:EnableMouse(false)
CooldownFrameContainer:SetMovable(true)
CooldownFrameContainer:RegisterForDrag("LeftButton")
CooldownFrameContainer:SetScript("OnDragStart", CooldownFrameContainer.StartMoving)
CooldownFrameContainer:SetScript("OnDragStop", CooldownFrameContainer.StopMovingOrSizing)

-- Shark Infested Waters cooldown frame
local SIWCooldownFrame = CreateFrame("Frame", "TTB_SIWCooldownFrame", CooldownFrameContainer)
SIWCooldownFrame:SetSize(40, 40)
SIWCooldownFrame:SetPoint("LEFT", 10, 0)
SIWCooldownFrame:SetAlpha(.25)
local texture = SIWCooldownFrame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture("Interface\\Icons\\Ability_rogue_rollthebones03")
local SIWCooldown = CreateFrame("Cooldown", "SIWCooldown", SIWCooldownFrame, "CooldownFrameTemplate")
SIWCooldown:SetReverse(true)
SIWCooldown:SetSize(40, 40)

-- True Bearing cooldown frame
local TBCooldownFrame = CreateFrame("Frame", "TTB_TBCooldownFrame", CooldownFrameContainer)
TBCooldownFrame:SetSize(40, 40)
TBCooldownFrame:SetPoint("LEFT", 60, 0)
TBCooldownFrame:SetAlpha(.25)
local texture = TBCooldownFrame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture("Interface\\Icons\\Ability_rogue_rollthebones04")
local TBCooldown = CreateFrame("Cooldown", "TBCooldown", TBCooldownFrame, "CooldownFrameTemplate")
TBCooldown:SetReverse(true)
TBCooldown:SetSize(40, 40)

-- Jolly Roger cooldown frame
local JRCooldownFrame = CreateFrame("Frame", "TTB_JRCooldownFrame", CooldownFrameContainer)
JRCooldownFrame:SetSize(40, 40)
JRCooldownFrame:SetPoint("LEFT", 110, 0)
JRCooldownFrame:SetAlpha(.25)
local texture = JRCooldownFrame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture("Interface\\Icons\\Ability_rogue_rollthebones01")
local JRCooldown = CreateFrame("Cooldown", "JRCooldown", JRCooldownFrame, "CooldownFrameTemplate")
JRCooldown:SetReverse(true)
JRCooldown:SetSize(40, 40)

-- Broadsides cooldown frame
local BCooldownFrame = CreateFrame("Frame", "TTB_BCooldownFrame", CooldownFrameContainer)
BCooldownFrame:SetSize(40, 40)
BCooldownFrame:SetPoint("LEFT", 160, 0)
BCooldownFrame:SetAlpha(.25)
local texture = BCooldownFrame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture("Interface\\Icons\\Ability_rogue_rollthebones07")
local BCooldown = CreateFrame("Cooldown", "BCooldown", BCooldownFrame, "CooldownFrameTemplate")
BCooldown:SetReverse(true)
BCooldown:SetSize(40, 40)

-- Buried Treasure frame
local BTCooldownFrame = CreateFrame("Frame", "TTB_BTCooldownFrame", CooldownFrameContainer)
BTCooldownFrame:SetSize(40, 40)
BTCooldownFrame:SetPoint("LEFT", 210, 0)
BTCooldownFrame:SetAlpha(.25)
local texture = BTCooldownFrame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture("Interface\\Icons\\Ability_rogue_rollthebones05")
local BTCooldown = CreateFrame("Cooldown", "BTCooldown", BTCooldownFrame, "CooldownFrameTemplate")
BTCooldown:SetReverse(true)
BTCooldown:SetSize(40, 40)

-- Grand Melee frame
local GMCooldownFrame = CreateFrame("Frame", "TTB_GMCooldownFrame", CooldownFrameContainer)
GMCooldownFrame:SetSize(40, 40)
GMCooldownFrame:SetPoint("LEFT", 260, 0)
GMCooldownFrame:SetAlpha(.25)
local texture = GMCooldownFrame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture("Interface\\Icons\\Ability_rogue_rollthebones02")
local GMCooldown = CreateFrame("Cooldown", "GMCooldown", GMCooldownFrame, "CooldownFrameTemplate")
GMCooldown:SetReverse(true)
GMCooldown:SetSize(40, 40)

-- MessageFrame to hold textual output of buffs
local BuffMessage = CreateFrame("MessageFrame", "TTB_BuffMessage", TestFrame)
BuffMessage:SetWidth(70)
BuffMessage:SetHeight(100)
BuffMessage:SetPoint("topleft", Center, "topleft", 10, -10)
BuffMessage:SetMovable(true)
--Make movable
BuffMessage:RegisterForDrag("LeftButton")
BuffMessage:SetScript("OnDragStart", BuffMessage.StartMoving)
BuffMessage:SetScript("OnDragStop", BuffMessage.StopMovingOrSizing)

BuffMessage:SetBackdrop({
	bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
	tile = true, tileSize = 16, edgeSize = 16,
	insets = { left = 3, right = 3, top = 5, bottom = 3 }
})

BuffMessage:SetFading(false)
BuffMessage:SetFontObject("GameFontNormalSmall")
BuffMessage:SetJustifyH("left")
BuffMessage:SetJustifyV("center")
BuffMessage:SetSpacing("2")
BuffMessage:Hide()

local SharkInfestedWaters = "193357"
local TrueBearing = "193359"
local JollyRoger = "199603"
local Broadsides = "193356"
local BuriedTreasure = "199600"
local GrandMelee = "193358"

local buffs = {
	[SharkInfestedWaters] = {
		["active"] = false,
		["abbr"] = "Crit",
		["red"] = 1,
		["green"] = 1,
		["blue"] = 1,
		["frame"] = SIWCooldownFrame,
		["cdframe"] = SIWCooldown,
	},
	[TrueBearing] = {
		["active"] = false,
		["abbr"] = "CD Reduce",
		["red"] = 1,
		["green"] = 1,
		["blue"] = 1,
		["frame"] = TBCooldownFrame,
		["cdframe"] = TBCooldown,
	},
	[JollyRoger] = {
		["active"] = false,
		["abbr"] = "Saber%",
		["red"] = 1,
		["green"] = 1,
		["blue"] = 1,
		["frame"] = JRCooldownFrame,
		["cdframe"] = JRCooldown,
	},
	[Broadsides] = {
		["active"] = false,
		["abbr"] = "+CP",
		["red"] = 1,
		["green"] = 1,
		["blue"] = 1,
		["frame"] = BCooldownFrame,
		["cdframe"] = BCooldown,
	},
	[BuriedTreasure] = {
		["active"] = false,
		["abbr"] = "Energy Reg",
		["red"] = 1,
		["green"] = 1,
		["blue"] = 1,
		["frame"] = BTCooldownFrame,
		["cdframe"] = BTCooldown,
	},
	 -- Handgemenge/Grand Melee
	[GrandMelee] = {
		["active"] = false,
		["abbr"] = "AS + Leech",
		["red"] = 1,
		["green"] = 1,
		["blue"] = 1,
		["frame"] = GMCooldownFrame,
		["cdframe"] = GMCooldown,
	},
}

-- For retrieving the buffs in order (roughly best to worst)
local buffsOrdered = {
	SharkInfestedWaters,
	TrueBearing,
	JollyRoger,
	Broadsides,
	BuriedTreasure,
	GrandMelee,
}

-- Addon initialization
local outlaw = false -- if current spec is outlaw
local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("ADDON_LOADED")
EventFrame:SetScript("OnEvent", function(self, event, ...)
	if(event == "ADDON_LOADED") then
		-- Only load addon if current class is rogue
		classDisplayName, class, classID = UnitClass("player")
		if(classID == 4) then
			-- Set event handler for talent switch
			EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
			-- Initialize saved variables if called for the first time
			SetStandardValues()
			local currentSpecIndex = GetSpecialization()
			local currentSpecId = currentSpecIndex and select(1, GetSpecializationInfo(currentSpecIndex)) or "None"
			if(currentSpecId == 260) then
				EventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
				EventFrame:RegisterEvent("UNIT_AURA")
				EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
				EventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
				outlaw = true
				ConfigureDisplay()
			end
		end
	end
	
	if(event == "ACTIVE_TALENT_GROUP_CHANGED") then
		if(GetSpecializationInfo(GetSpecialization()) == 260) then
			EventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			EventFrame:RegisterEvent("UNIT_AURA")
			EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
			EventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
			outlaw = true
			ConfigureDisplay()
		else
			EventFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			EventFrame:UnregisterEvent("UNIT_AURA")
			EventFrame:UnregisterEvent("PLAYER_REGEN_ENABLED")
			EventFrame:UnregisterEvent("PLAYER_REGEN_DISABLED")
			outlaw = false
			ConfigureDisplay()
		end
	end
	
	-- Clear the MessageFrame/Set every Cooldown Icon to inactive if no buff is up
	if(event == "UNIT_AURA") then
		local hasBuff = false
		for key, value in ipairs(buffsOrdered) do
			if(UnitBuff("player", GetSpellInfo(value))) then
				hasBuff = true
			end
		end
		if(hasBuff == false) then
			BuffMessage:Clear()
			for key, value in ipairs(buffsOrdered) do
				buffs[value]["frame"]:SetAlpha(.25)
			end
		end
	end

	-- Show/hide textbox/icon box if entering/leaving combat
	if(event == "PLAYER_REGEN_DISABLED" and TTBDB.textboxmode == true) then
		UIFrameFadeIn(BuffMessage, 1, 0, 1)
	end
	if(event == "PLAYER_REGEN_DISABLED" and TTBDB.iconmode == true) then
		UIFrameFadeIn(CooldownFrameContainer, 1, 0, 1)
	end
	if(event == "PLAYER_REGEN_ENABLED" and TTBDB.textboxmode == true) then
		UIFrameFadeOut(BuffMessage, 1, 1, 0)
	end
	if(event == "PLAYER_REGEN_ENABLED" and TTBDB.iconmode == true) then
		UIFrameFadeOut(CooldownFrameContainer, 1, 1, 0)
	end
	
	if(event == "UNIT_SPELLCAST_SUCCEEDED") then
		local unit = ...
		local unitID, spell, rank, lineID, spellID = select(1, ...)
		if(unit ~= "player" or spellID ~= 193316) then -- Check if player rolled the bones: return if not
			return
		end
		local amount = 0 -- Number of buffs active
		TTBDB.rolls = TTBDB.rolls + 1
		TTBDB.lastsix = TTBDB.lastsix + 1
		-- Update buff table
		for buff in pairs(buffs) do
			local isActive = select(11, UnitBuff("player", GetSpellInfo(buff)))
			if(tostring(isActive) == tostring(buff)) then
				buffs[buff]["active"] = true
				buffs[buff]["red"] = 1.0
				buffs[buff]["green"] = 0
				buffs[buff]["blue"] = 0
				amount = amount + 1
			else
				buffs[buff]["active"] = false
				buffs[buff]["red"] = 1
				buffs[buff]["green"] = 1
				buffs[buff]["blue"] = 1
			end
		end
		-- Update the textbox/icon box if mode is set to true
		if(TTBDB.textboxmode == true) then
			DisplayText()
		end
		if(TTBDB.iconmode == true) then
			DisplayCooldownIcons()
		end
		if(amount > 1) then
			if(TTBDB.rolls >= TTBDB.threshold) then -- Message after ending the bad luck streak
				SendChatMessage(string.gsub(TTBDB.finallyMessage, '{n}', TTBDB.rolls), "yell")
				-- Update record
				if(TTBDB.rolls > TTBDB.record) then
					TTBDB.record = TTBDB.rolls
				end
			end
			TTBDB.rolls = 0
		end
		if(amount == 6) then -- Message for six buffs
			-- Update lastsixrecord
			if(TTBDB.lastsix > TTBDB.lastsixrecord) then
				TTBDB.lastsixrecord = TTBDB.lastsix
			end
			SendChatMessage(string.gsub(TTBDB.hamMessage, '{n}', TTBDB.lastsix), "yell")
			TTBDB.rolls = 0
			TTBDB.lastsix = 0
			-- Play Leeroy
			if(TTBDB.leeroy == true) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\leeroy-jenkins.ogg", "Master")
			end
		end
		-- Play sounds
		if(TTBDB.playsound == true) then
			if(amount == 1) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\1-one.ogg", "Master")
			elseif(amount == 2) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\2-two.ogg", "Master")
			elseif(amount == 3) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\3-three.ogg", "Master")
			elseif(amount == 6) then
				if(TTBDB.leeroy == false) then
					PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\6-six.ogg", "Master")
				end
			end
		end
	end
end)

-- Textual output of buffs
function DisplayText()
	BuffMessage:Clear()
	for key, value in ipairs(buffsOrdered) do
		if(buffs["" .. value]["active"] == true) then
			BuffMessage:AddMessage("  " .. buffs["" .. value]["abbr"], 1.0, 0, 0, 1)
		else
			BuffMessage:AddMessage("  " .. buffs["" .. value]["abbr"], 1, 1, 1, 1)
		end
	end
end

-- Graphical representation of buffs
function DisplayCooldownIcons()
	for key, value in ipairs(buffsOrdered) do
		if(buffs[value]["active"] == true) then
			buffs[value]["frame"]:SetAlpha(1)
			local duration = select(7, UnitBuff("player", GetSpellInfo(value))) - GetTime()
			buffs[value]["cdframe"]:SetCooldown(GetTime(), math.ceil(duration))
		else
			buffs[value]["frame"]:SetAlpha(.25)
			buffs[value]["cdframe"]:SetCooldown(0, 0)
		end
	end
end

-- Set standard saved variables
function SetStandardValues()
	if(TTBDB == nil) then
		TTBDB = {}
	end
	if(not TTBDB.rolls) then
		TTBDB.rolls = 0
	end
	if(not TTBDB.hamMessage) then
		TTBDB.hamMessage = "I rolled 'em all. Pulling Azeroth NOW!"
	end
	if(not TTBDB.finallyMessage) then
		TTBDB.finallyMessage = "I was just trolled by the bones {n} times."
	end
	if(not TTBDB.threshold) then
		TTBDB.threshold = 5
	end
	if(not TTBDB.playsound) then
		TTBDB.playsound = false
	end
	if(not TTBDB.leeroy) then
		TTBDB.leeroy = false
	end
	if(not TTBDB.record) then
		TTBDB.record = 0
	end
	if(not TTBDB.lastsix) then
		TTBDB.lastsix = 0
	end
	if(not TTBDB.lastsixrecord) then
		TTBDB.lastsixrecord = 0
	end
	if(not TTBDB.textboxmode) then
		TTBDB.textboxmode = false
	end
	if(not TTBDB.showtextbox) then
		TTBDB.showtextbox = false
	end
	if(not TTBDB.locktextbox) then
		TTBDB.locktextbox = false
	end
	if(not TTBDB.iconmode) then
		TTBDB.iconmode = false
	end
	if(not TTBDB.showicons) then
		TTBDB.showicons = false
	end
	if(not TTBDB.lockicons) then
		TTBDB.lockicons = false
	end
end

function ConfigureDisplay()
	if(TTBDB.locktextbox == true and outlaw == true) then
		BuffMessage:EnableMouse(false)
	else
		BuffMessage:EnableMouse(true)
	end
	if(TTBDB.lockicons == true and outlaw == true) then
		CooldownFrameContainer:EnableMouse(false)
	else
		CooldownFrameContainer:EnableMouse(true)
	end
end

-- Addon control panel
ACPanel = CreateFrame("Frame", "TTB_ACPanel", UIParent)
ACPanel.name = "Troll The Bones"
InterfaceOptions_AddCategory(ACPanel)

-- Check Button creator
local uniquealyzer = 1
function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1
	
	local checkbutton = CreateFrame("CheckButton", "TTB_CheckButton0" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate")
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc)
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname)

	return checkbutton
end

local LeeroyCheckbox = createCheckbutton(ACPanel, 10, -10, "Leeroy mode")
LeeroyCheckbox.tooltip = "Turn it on and scream along!"

local PlaySoundCheckbox = createCheckbutton(ACPanel, 10, -40, "Play sound")
PlaySoundCheckbox.tooltip = "Check to play a short sound (\"One\" to \"Six\") after gaining bones buffs."

local TextboxModeCheckbox = createCheckbutton(ACPanel, 10, -120, "Textbox mode")
TextboxModeCheckbox.tooltip = "When in combat, this option displays a little textbox showing the six buffs line by line, roughly ordered from best to worst."

local IconModeCheckbox = createCheckbutton(ACPanel, 10, -150, "Icon mode")
IconModeCheckbox.tooltip = "When in combat, this will display a bar with the icons for your six buffs showing which are active. They are roughly ordered from best to worst (left to right). "

-- Threshold Slider
local name = "Roll Threshold"
local template = "OptionsSliderTemplate"
local ACPThresholdSlider = CreateFrame("Slider", name, ACPanel, template)
ACPThresholdSlider:SetPoint("TOPLEFT", 10, -90)
ACPThresholdSlider.textLow = _G[name .. "Low"]
ACPThresholdSlider.textHigh = _G[name .. "High"]
ACPThresholdSlider.text = _G[name.."Text"]
ACPThresholdSlider:SetMinMaxValues(1, 25)
ACPThresholdSlider.minValue, ACPThresholdSlider.maxValue = ACPThresholdSlider:GetMinMaxValues() 
ACPThresholdSlider.textLow:SetText(ACPThresholdSlider.minValue)
ACPThresholdSlider.textHigh:SetText(ACPThresholdSlider.maxValue)
ACPThresholdSlider.text:SetText(name)
ACPThresholdSlider:EnableMouseWheel(true)
ACPThresholdSlider.tooltipText = "Sets the number of rolls you have to experience painfully before the addon starts yelling."
ACPThresholdSlider:SetValueStep(1)
ACPThresholdSlider:SetScript("OnMouseWheel", function(self, delta)
	if delta > 0 then
		self:SetValue(self:GetValue() + self:GetValueStep())
	else
		self:SetValue(self:GetValue() - self:GetValueStep())
	end
end)
ACPThresholdSlider:SetScript("OnValueChanged", function(self,event,arg1)
	ACPThresholdSlider.text:SetText("Roll Threshold (" .. math.floor(event) .. ")")
end)

-- Ham EditBox
local ACPHamInputBox = CreateFrame("EditBox", nil, ACPanel, "InputBoxTemplate")
ACPHamInputBox:SetHeight(35)
ACPHamInputBox:SetWidth(250)
ACPHamInputBox:SetPoint("TOPLEFT", 10, -200)
ACPHamInputBox:SetFontObject("GameFontHighlight")
ACPHamInputBox:SetTextInsets(0, 0, 0, 1)
ACPHamInputBox:SetAutoFocus(false)
ACPHamInputBox:SetCursorPosition(0)

local ACPHamInputBoxLabel = CreateFrame('Frame', "ACPHamInputBoxLabel", ACPanel)
ACPHamInputBoxLabel:SetWidth(95)
ACPHamInputBoxLabel:SetHeight(20)
ACPHamInputBoxLabel:SetPoint('TOPLEFT', 10, -180)

local ACPHamInputBoxLabelText = ACPHamInputBoxLabel:CreateFontString()
ACPHamInputBoxLabelText:SetPoint("LEFT")
ACPHamInputBoxLabelText:SetSize(95, 20)
ACPHamInputBoxLabelText:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
ACPHamInputBoxLabelText:SetText("Ham message")

-- Finally EditBox
local ACPFinallyInputBox = CreateFrame("EditBox", nil, ACPanel, "InputBoxTemplate")
ACPFinallyInputBox:SetHeight(35)
ACPFinallyInputBox:SetWidth(250)
ACPFinallyInputBox:SetPoint("TOPLEFT", 10, -260)
ACPFinallyInputBox:SetFontObject("GameFontHighlight")
ACPFinallyInputBox:SetTextInsets(0, 0, 0, 1)
ACPFinallyInputBox:SetAutoFocus(false)
ACPFinallyInputBox:SetCursorPosition(0)

local ACPFinallyInputBoxLabel = CreateFrame('Frame', "ACPFinallyInputBoxLabel", ACPanel)
ACPFinallyInputBoxLabel:SetWidth(105)
ACPFinallyInputBoxLabel:SetHeight(20)
ACPFinallyInputBoxLabel:SetPoint('TOPLEFT', 10, -240)

local ACPFinallyInputBoxLabelText = ACPFinallyInputBoxLabel:CreateFontString()
ACPFinallyInputBoxLabelText:SetPoint("LEFT")
ACPFinallyInputBoxLabelText:SetSize(105, 20)
ACPFinallyInputBoxLabelText:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
ACPFinallyInputBoxLabelText:SetText("Finally message")

-- Populate the control panel with the content of TTBDB
ACPanel:SetScript("OnShow", function(self)
	LeeroyCheckbox:SetChecked(TTBDB.leeroy)
	PlaySoundCheckbox:SetChecked(TTBDB.playsound)
	TextboxModeCheckbox:SetChecked(TTBDB.textboxmode)
	IconModeCheckbox:SetChecked(TTBDB.iconmode)
	ACPThresholdSlider.text:SetText("Roll Threshold (" .. TTBDB.threshold .. ")")
	ACPThresholdSlider:SetValue(TTBDB.threshold)
	ACPHamInputBox:SetText(TTBDB.hamMessage)
	ACPFinallyInputBox:SetText(TTBDB.finallyMessage)
end)

-- Save changes after click on 'Okay'
ACPanel.okay = function(self)
	TTBDB.leeroy = LeeroyCheckbox:GetChecked()
	TTBDB.playsound = PlaySoundCheckbox:GetChecked()
	TTBDB.textboxmode = TextboxModeCheckbox:GetChecked()
	if(TextboxModeCheckbox:GetChecked() == false) then
		TTBDB.showtextbox = false
		
		if(BuffMessage:IsShown() == true) then
			UIFrameFadeOut(BuffMessage, 1, 1, 0)
		end
	end
	TTBDB.iconmode = IconModeCheckbox:GetChecked()
	if(IconModeCheckbox:GetChecked() == false) then
		TTBDB.showicons = false
		
		if(CooldownFrameContainer:IsShown() == true) then
			UIFrameFadeOut(CooldownFrameContainer, 1, 1, 0)
		end
	end
	TTBDB.threshold = math.floor(ACPThresholdSlider:GetValue())
	TTBDB.hamMessage = ACPHamInputBox:GetText()
	TTBDB.finallyMessage = ACPFinallyInputBox:GetText()
end

-- Slash commands
SLASH_TTB1 = '/ttb'
function SlashCmdList.TTB(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	if(command == "" and rest == "") then
		InterfaceOptionsFrame_OpenToCategory(ACPanel.name);
		InterfaceOptionsFrame_OpenToCategory(ACPanel.name);
	elseif(command == "ham" and rest ~= "") then
		print("Ham message set to: " .. rest)
		TTBDB.hamMessage = rest
		ACPHamInputBox:SetText(TTBDB.hamMessage)
	elseif(command == "ham" and rest == "") then
		print("Ham message currently is: " .. TTBDB.hamMessage)
	elseif(command == "finally" and rest ~= "") then 
		print("Finally message set to: " .. rest)
		TTBDB.finallyMessage = rest
	elseif(command == "finally" and rest == "") then
		print("Finally message currently is: " .. TTBDB.finallyMessage)
	elseif(command == "threshold" and rest ~= "" and tonumber(rest) ~= nil) then
		if(tonumber(rest) > 0 and tonumber(rest) <= 25) then
			print("Threshold set to: " .. rest);
			TTBDB.threshold = tonumber(rest)
			ACPThresholdSlider:SetValue(TTBDB.threshold)
		else
			print("Please specify a number between 1 and 25.")
		end
	elseif(command == "threshold" and rest == "") then
		print("Threshold currently is: " .. TTBDB.threshold)
	elseif(command == "playsound" and rest == "") then
		print("Sound output currently is set to: " .. tostring(TTBDB.playsound))
	elseif(command == "record" and rest == "") then
		print("Your current record of rerolling is " .. TTBDB.record .. ". Your longest dry spell was " .. TTBDB.lastsixrecord .. " rolls.")
	elseif(command == "lastsix" and rest == "") then
		print("The last time you've rolled 'em all was " .. (TTBDB.lastsix + 1) .. " rolls ago.")
	elseif(command == "playsound" and (rest == "false" or rest == "true")) then
		if(rest == "true") then
			TTBDB.playsound = true
			PlaySoundCheckbox:SetChecked(true)
		elseif(rest == "false") then
			TTBDB.playsound = false
			PlaySoundCheckbox:SetChecked(false)
		end
		print("Sound output set to: " .. tostring(TTBDB.playsound))
	elseif(command == "leeroy" and rest == "") then
		print("Leeroy mode currently is set to: " .. tostring(TTBDB.leeroy))
	elseif(command == "leeroy" and (rest == "true" or rest == "false")) then
		if(rest == "true") then
			TTBDB.leeroy = true
			LeeroyCheckbox:SetChecked(true)
		elseif(rest == "false") then
			TTBDB.leeroy = false
			LeeroyCheckbox:SetChecked(false)
		end
		print("Leeroy mode set to: " .. tostring(TTBDB.leeroy))
	elseif(command == "textboxmode" and (rest == "true" or rest == "false")) then
		if(rest == "true") then
			TTBDB.textboxmode = true
			TextboxModeCheckbox:SetChecked(true)
		elseif(rest == "false") then
			TTBDB.textboxmode = false
			TTBDB.showtextbox = false
			TextboxModeCheckbox:SetChecked(false)
			UIFrameFadeOut(BuffMessage, 1, 1, 0)
		end
		print("Textbox mode set to: " .. tostring(TTBDB.textboxmode))
	elseif(command == "showtextbox") then
		TTBDB.showtextbox = true
		UIFrameFadeIn(BuffMessage, 1, 0, 1)
	elseif(command == "hidetextbox") then
		TTBDB.showtextbox = false
		if(BuffMessage:IsShown() == true) then
			UIFrameFadeOut(BuffMessage, 1, 1, 0)
		end
	elseif(command == "locktextbox") then
		TTBDB.locktextbox = true
		BuffMessage:EnableMouse(false)
	elseif(command == "unlocktextbox") then
		TTBDB.locktextbox = false
		BuffMessage:EnableMouse(true)
	elseif(command == "iconmode" and (rest == "true" or rest == "false")) then
		if(rest == "true") then
			TTBDB.iconmode = true
		elseif(rest == "false") then
			TTBDB.iconmode = false
			TTBDB.showicons = false
			CooldownFrameContainer:Hide()
		end
		print("Icon mode mode set to: " .. tostring(TTBDB.iconmode))
	elseif(command == "showicons") then
		TTBDB.showicons = true
		UIFrameFadeIn(CooldownFrameContainer, 1, 0, 1)
	elseif(command == "hideicons") then
		TTBDB.showicons = false
		UIFrameFadeOut(CooldownFrameContainer, 1, 1, 0)
	elseif(command == "lockicons") then
		TTBDB.lockicons = true
		CooldownFrameContainer:EnableMouse(false)
	elseif(command == "unlockicons") then
		TTBDB.lockicons = false
		CooldownFrameContainer:EnableMouse(true)
	else
		print("This is not a command of Troll The Bones. Please consider reading the documentation at https://mods.curse.com/addons/wow/troll-the-bones.")
	end
end